#include "mywindow1.h"
#include <gtkmm.h>
#include <iostream>
#include <sstream>
#include <cstdlib>
#include <cstdio>
#include <ctime>
using namespace std;
//randomize();

/*void mywindow2::dialog(Glib::ustring msg){
    Gtk::MessageDialog dlg(msg,false,Gtk::MESSAGE_INFO,Gtk::BUTTONS_OK, true);
    dlg.run();
    }
void mywindow6::dialog(Glib::ustring msg){
    Gtk::MessageDialog dlg(msg,false,Gtk::MESSAGE_INFO,Gtk::BUTTONS_OK, true);
    dlg.run();
    }*/

mywindow::mywindow()
{
    //set_background("blue");
    set_default_size(300, 300);
    set_title("Su-do-ku");
    set_modal(true) ;

    Gtk::Box *vbox = Gtk::manage(new Gtk::Box(Gtk::ORIENTATION_VERTICAL, 0));
    add(*vbox);

    Gtk::MenuBar *menubar = Gtk::manage(new Gtk::MenuBar());
    vbox->pack_start(*menubar, Gtk::PACK_SHRINK, 0);

    Gtk::MenuItem *menuitem_file = Gtk::manage(new Gtk::MenuItem("_File", true));
    menubar->append(*menuitem_file);
    Gtk::Menu *filemenu = Gtk::manage(new Gtk::Menu());
    menuitem_file->set_submenu(*filemenu);
    Gtk::MenuItem *menuitem_quit = Gtk::manage(new Gtk::MenuItem("_Quit", true));
    menuitem_quit->signal_activate().connect(sigc::mem_fun(*this, &mywindow::on_quit_window1_click));
    filemenu->append(*menuitem_quit);

    Gtk::Grid *grid = Gtk::manage(new Gtk::Grid);
    grid->set_border_width(10);
    //grid->set_column_spacing(100);
    //grid->set_row_spacing(100);
    vbox->add(*grid);
    Gtk::Label *l3= Gtk::manage(new Gtk::Label(" "));
    grid->attach(*l3, 0, 0, 1, 1);
    l3->set_hexpand(true);
    Gtk::Label *l1= Gtk::manage(new Gtk::Label());
    l1->set_markup("<b>SUDOKU</b>");
    grid->attach(*l1, 2, 0, 1, 1);
    l1->set_hexpand(true);

    Gtk::Label *l2= Gtk::manage(new Gtk::Label(" "));
    grid->attach(*l2, 4, 0, 1, 1);
    l2->set_hexpand(true);
    //Gtk::Label *b1label= Gtk::manage(new Gtk::Label());
    //b1label->set_markup("<b>Hello</b>");
    Gtk::Button *b1 = Gtk::manage(new Gtk::Button("New Game"));

    //b1->set_hexpand(true);
    //b1->set_vexpand(true);
    b1->signal_clicked().connect(sigc::mem_fun(*this, &mywindow::on_new_game_click));
    grid->attach(*b1, 2, 3, 1, 1);
    //b1->add(*b1label);
    b1->set_hexpand(true);



    Gtk::Label *l4= Gtk::manage(new Gtk::Label(" "));
    grid->attach(*l4, 0, 1, 1, 1);
    l4->set_hexpand(true);
    /*Gtk::Label *l5= Gtk::manage(new Gtk::Label(" "));
    grid->attach(*l5, 2, 1, 1, 1);
    l5->set_hexpand(true);*/
    Gtk::Label *l6= Gtk::manage(new Gtk::Label(" "));
    grid->attach(*l6, 0, 2, 1, 1);
    l6->set_hexpand(true);
    /*Gtk::Label *l7= Gtk::manage(new Gtk::Label(" "));
    grid->attach(*l7, 0, 3, 1, 1);
    l7->set_hexpand(true);*/
    //Gtk::Label *l6= Gtk::manage(new Gtk::Label(" "));
    //grid->attach(*l6, 4, 0, 1, 1);
    //l6->set_hexpand(true);
    Gtk::Label *l7= Gtk::manage(new Gtk::Label(" "));
    grid->attach(*l7, 0, 4, 1, 1);
    l7->set_hexpand(true);
    Gtk::Label *l8= Gtk::manage(new Gtk::Label(" "));
    grid->attach(*l8, 0, 6, 1, 1);
    l8->set_hexpand(true);
    Gtk::Label *l9= Gtk::manage(new Gtk::Label(" "));
    grid->attach(*l9, 0, 8, 1, 1);
    l9->set_hexpand(true);


    Gtk::Button *b2 = Gtk::manage(new Gtk::Button("Auto-Solver"));
    b2->signal_clicked().connect(sigc::mem_fun(*this, &mywindow::on_sudoku_solver_click));
    grid->attach(*b2, 2, 5, 1, 1);

    Gtk::Button *b3 = Gtk::manage(new Gtk::Button("High Scores"));
    b3->signal_clicked().connect(sigc::mem_fun(*this, &mywindow::on_high_scores_click));
    grid->attach(*b3, 2, 7, 1, 1);

    vbox->show_all();
}

mywindow::~mywindow()
{

  std::map<int, new_game_mypopup*>::iterator iter;
    for (iter = popups.begin(); iter != popups.end(); iter++)
    {
        new_game_mypopup *popup = iter->second;

        std::stringstream ss;
        ss << "Deleting Window '" << iter->first << "'";
        std::cout << ss.str() << std::endl;

        delete popup->popup;
        //delete popup->popup3;
        delete popup;
    }
     std::map<int, sudoku_solver_mypopup*>::iterator iter1;
    for (iter1 = popups1.begin(); iter1 != popups1.end(); iter1++)
    {
        sudoku_solver_mypopup *popup = iter1->second;

        std::stringstream ss1;
        ss1 << "Deleting Window '" << iter1->first << "'";
        std::cout << ss1.str() << std::endl;

        delete popup->popup;
        //delete popup->popup3;
        delete popup;
    }
     std::map<int, high_scores_mypopup*>::iterator iter2;
    for (iter2 = popups2.begin(); iter2 != popups2.end(); iter2++)
    {
        high_scores_mypopup *popup = iter2->second;

        std::stringstream ss2;
        ss2 << "Deleting Window '" << iter2->first << "'";
        std::cout << ss2.str() << std::endl;

        delete popup->popup;
        //delete popup->popup3;
        delete popup;
    }
    //dtor
}

void mywindow::on_new_game_click()
{
     new_game_mypopup *popup = new new_game_mypopup;
    popup->popup = new mywindow3;
    popup->windowid = windowcnt1;

    std::stringstream ss;
    ss << "NEW GAME" << windowcnt1 << "'";
    popup->popup->set_title(ss.str());
    popup->popup->signal_hide().connect(sigc::bind<new_game_mypopup*>(sigc::mem_fun(*this, &mywindow::on_new_game_popup_close), popup));

    popups[windowcnt1] = popup;
    windowcnt1++;

    popup->popup->show();
}



void mywindow::on_sudoku_solver_click()
{
   sudoku_solver_mypopup *popup = new sudoku_solver_mypopup;
    popup->popup = new mywindow2;
    popup->windowid = windowcnt2;

    std::stringstream ss;
    ss << "SUDOKU SOLVER" << windowcnt2<< "'";
    popup->popup->set_title(ss.str());
   // popup->popup->signal_hide().connect(sigc::bind<sudoku_solver_mypopup*>(sigc::mem_fun(*this, &mywindow::on_sudoku_solver_popup_close), popup));

    //popups[windowcnt2] = popup;
    windowcnt2++;

    popup->popup->show();
}

void mywindow::on_high_scores_click()
{
    high_scores_mypopup *popup = new high_scores_mypopup;
    popup->popup = new mywindow4;
    popup->windowid = windowcnt3;

    std::stringstream ss;
    ss << "HIGH SCORES" << windowcnt3 << "'";
    popup->popup->set_title(ss.str());
   // popup->popup->signal_hide().connect(sigc::bind<high_scores_mypopup*>(sigc::mem_fun(*this, &mywindow::on_high_scores_popup_close), popup));

   // popups[windowcnt3] = popup;
    windowcnt3++;

    popup->popup->show();
}

void mywindow::on_new_game_popup_close(new_game_mypopup *popup)
{
    std::stringstream ss;

    ss << "Deleting Window '" << popup->windowid << "'";
    std::cout << ss.str() << std::endl;

    popups.erase(popup->windowid);
    delete popup->popup;
    delete popup;
}
void mywindow::on_sudoku_solver_popup_close(sudoku_solver_mypopup *popup)
{
    std::stringstream ss;

    ss << "Deleting Window '" << popup->windowid << "'";
    std::cout << ss.str() << std::endl;

    popups1.erase(popup->windowid);
    delete popup->popup;
    delete popup;
}
void mywindow::on_high_scores_popup_close(high_scores_mypopup *popup)
{
    std::stringstream ss;

    ss << "Deleting Window '" << popup->windowid << "'";
    std::cout << ss.str() << std::endl;

    popups2.erase(popup->windowid);
    delete popup->popup;
    delete popup;
}


mywindow2::mywindow2()
{    //int** sudoku2;
     set_modal(true);
     sudoku2=new int *[9];
     if(sudoku2==NULL){std::cout<<"MEMORY ALLOCATION FAILURE";}
     for(int k=0;k<9;k++){ sudoku2[k]= new int[9];
                            if (sudoku2[k]==NULL){std::cout<<"MEMORY ALLOCATION FAILURE";}}
     for (int l=0;l<9;l++){
            for(int m=0;m<9;m++){ sudoku2[l][m]=0;}}

    set_default_size(200, 200);
    set_title("SUDOKU SOLVER");
    set_border_width(10);

    Gtk::Button ***buttons;
    buttons=new Gtk::Button **[9];
    for(int k=0;k<9;k++){ buttons[k]= new Gtk::Button*[9];}


    Gtk::Box *vbox = Gtk::manage(new Gtk::Box(Gtk::ORIENTATION_VERTICAL, 0));
    add(*vbox);

    Gtk::Grid *grid = Gtk::manage(new Gtk::Grid);
    grid->set_border_width(40);
    vbox->add(*grid);

 //std::string buttonIdStr[9][9];
 for(int i=0; i<9;i++) {
    for(int j=0; j<9 ;j++){
    // std::stringstream ss;
    // ss << (j+1)*10+(i+1);
     //buttonIdStr[i][j] = ss.str();
      buttons[i][j]=Gtk::manage(new Gtk::Button("0"));


      buttons[i][j]->signal_clicked().connect(sigc::bind<int,int,int** , Gtk::Button*>(sigc::mem_fun(*this, &mywindow2::on_button_click),i,j,sudoku2,buttons[i][j]));

      grid->attach(*buttons[i][j],i,j,1,1);




     }
     }

     Gtk::Button *solve=Gtk::manage(new Gtk::Button("Solve"));
     grid->attach(*solve,3,13,3,3);

     solve->signal_clicked().connect(sigc::bind<int**,Gtk::Button*** >(sigc::mem_fun(*this, &mywindow2::on_solve_click),sudoku2,buttons));




//m_Button_Quit.signal_clicked().connect(sigc::mem_fun(*this,&ExampleWindow::on_button_quit) );
    vbox->show_all();
    show_all_children();

    //Gtk::Entry *eusername = Gtk::manage(new Gtk::Entry());
    //eusername->set_hexpand(true);
   // grid->attach(*eusername, 1, 1, 1, 1);


}

void mywindow2::on_solve_click(int** sudoku2, Gtk::Button*** buttons)
{
  if(sudoku_solver(sudoku2)==false){Gtk::MessageDialog dlg("INVALID SUDOKU", false, Gtk::MESSAGE_ERROR, Gtk::BUTTONS_OK, true);
                                    dlg.set_title("INVALID");
                                    dlg.run();}
  else{for(int x=0;x<9;x++){
        for(int y=0;y<9;y++){
                    std::stringstream ss;
                    ss<<sudoku2[x][y];
                    buttons[x][y]->set_label(ss.str());
                        }
                    }
        }
}

mywindow4::mywindow4()
{
    set_modal(true);
    set_default_size(500, 200);
    set_title("VIEW RECORDS");
    /*****************************ADDING THE LIST*******************************/


    Gtk::Box *vbox = Gtk::manage(new Gtk::Box(Gtk::ORIENTATION_VERTICAL, 0));
    add(*vbox);

    vbox->pack_start(m_Notebook);
    vbox->pack_start(m_ButtonBox, Gtk::PACK_SHRINK);
    m_ButtonBox.pack_start(m_Button_Quit, Gtk::PACK_SHRINK);
//    m_Button_Quit.signal_clicked().connect(sigc::mem_fun(*this,&mywindow4::on_button_quit) );

    Gtk::Label *easy= Gtk::manage(new Gtk::Label("EASY"));
    Gtk::Label *med= Gtk::manage(new Gtk::Label("MEDIUM"));
    Gtk::Label *diff= Gtk::manage(new Gtk::Label("DIFFICULT"));


   /* Gtk::Grid *grid = Gtk::manage(new Gtk::Grid);
    grid->set_border_width(10);
    grid->set_row_spacing(5);
    vbox->add(*grid);*/

    Gtk::TreeView *treeview_easy = Gtk::manage(new Gtk::TreeView);
    Gtk::TreeView *treeview_med = Gtk::manage(new Gtk::TreeView);
    Gtk::TreeView *treeview_diff = Gtk::manage(new Gtk::TreeView);

   // grid->attach(*treeview, 0, 0, 3, 1);
    //vbox->add(*treeview);
    m_Notebook.append_page(*treeview_easy,*easy);
    m_Notebook.append_page(*treeview_med,*med);
    m_Notebook.append_page(*treeview_diff,*diff);
    m_Notebook.signal_switch_page().connect(sigc::mem_fun(*this,&mywindow4::on_notebook_switch_page) );
     treeview_easy->set_hexpand(true);
    treeview_easy->set_vexpand(true);


    refTreeModel_easy = Gtk::ListStore::create(columns_easy);
    treeview_easy->set_model(refTreeModel_easy);
    treeview_easy->append_column("Sr. No.", columns_easy.sr_no);
    treeview_easy->append_column("Time(sec)", columns_easy.time);
    treeview_easy->append_column("Name", columns_easy.name);

    refTreeModel_med = Gtk::ListStore::create(columns_med);
    treeview_med->set_model(refTreeModel_med);
    treeview_med->append_column("Sr. No.", columns_med.sr_no);
    treeview_med->append_column("Time(sec)", columns_med.time);
    treeview_med->append_column("Name", columns_med.name);

    refTreeModel_diff = Gtk::ListStore::create(columns_diff);
    treeview_diff->set_model(refTreeModel_diff);
    treeview_diff->append_column("Sr. No.", columns_diff.sr_no);
    treeview_diff->append_column("Time(sec)", columns_diff.time);
    treeview_diff->append_column("Name", columns_diff.name);


    FILE *fhighScoresEasy;
    fhighScoresEasy=fopen("high_scores_easy.txt","r");
    //char b_id[30],b_name[30],a_name[30],b_status[30];
    {char p_string_easy[100],s1_easy[30],s2_easy[30];
     int i,j;
     while(!feof(fhighScoresEasy)){
        i=j=0;
		fgets(p_string_easy,99,fhighScoresEasy);
		if(feof(fhighScoresEasy))
            break;
		for(i=0;p_string_easy[j]!=',';s1_easy[i]=p_string_easy[j],i++,j++);
		s1_easy[i]='\0';
		for(i=0,++j;p_string_easy[j]!=',';s2_easy[i]=p_string_easy[j],i++,j++);
		s2_easy[i]='\0';
		//cout<<s1<<","<<s2<<","<<s3<<endl;
		/*strcpy(b_id,s1);
		strcpy(b_name,s2);
        strcpy(a_name,s3);
        strcpy(b_status,s4);*/
        /****************** ADD AND DISPLAY TO TREE VIEW/LIST **************************/
        Gtk::TreeModel::Row row_easy = *(refTreeModel_easy->append());
        rowcount_easy++;
        row_easy[columns_easy.sr_no] = rowcount_easy;
        row_easy[columns_easy.time] = s1_easy;
        row_easy[columns_easy.name] = s2_easy;


	}
	fclose(fhighScoresEasy);

	}

	    FILE *fhighScoresMed;
    fhighScoresMed=fopen("high_scores_med.txt","r");
    //char b_id[30],b_name[30],a_name[30],b_status[30];
    {char p_string_med[100],s1_med[30],s2_med[30];
     int i,j;
     while(!feof(fhighScoresMed)){
        i=j=0;
		fgets(p_string_med,99,fhighScoresMed);
		if(feof(fhighScoresMed))
            break;
		for(i=0;p_string_med[j]!=',';s1_med[i]=p_string_med[j],i++,j++);
		s1_med[i]='\0';
		for(i=0,++j;p_string_med[j]!=',';s2_med[i]=p_string_med[j],i++,j++);
		s2_med[i]='\0';
		//cout<<s1<<","<<s2<<","<<s3<<endl;
		/*strcpy(b_id,s1);
		strcpy(b_name,s2);
        strcpy(a_name,s3);
        strcpy(b_status,s4);*/
        /****************** ADD AND DISPLAY TO TREE VIEW/LIST **************************/
        Gtk::TreeModel::Row row_med = *(refTreeModel_med->append());
        rowcount_med++;
        row_med[columns_med.sr_no] = rowcount_med;
        row_med[columns_med.time] = s1_med;
        row_med[columns_med.name] = s2_med;


	}
	fclose(fhighScoresMed);
	}

	    FILE *fhighScoresDiff;
    fhighScoresDiff=fopen("high_scores_diff.txt","r");
    //char b_id[30],b_name[30],a_name[30],b_status[30];
    {char p_string_diff[100],s1_diff[30],s2_diff[30];
     int i,j;
     while(!feof(fhighScoresDiff)){
        i=j=0;
		fgets(p_string_diff,99,fhighScoresDiff);
		if(feof(fhighScoresDiff))
            break;
		for(i=0;p_string_diff[j]!=',';s1_diff[i]=p_string_diff[j],i++,j++);
		s1_diff[i]='\0';
		for(i=0,++j;p_string_diff[j]!=',';s2_diff[i]=p_string_diff[j],i++,j++);
		s2_diff[i]='\0';
		//cout<<s1<<","<<s2<<","<<s3<<endl;
		/*strcpy(b_id,s1);
		strcpy(b_name,s2);
        strcpy(a_name,s3);
        strcpy(b_status,s4);*/
        /****************** ADD AND DISPLAY TO TREE VIEW/LIST **************************/
        Gtk::TreeModel::Row row_diff = *(refTreeModel_diff->append());
        rowcount_diff++;
        row_diff[columns_diff.sr_no] = rowcount_diff;
        row_diff[columns_diff.time] = s1_diff;
        row_diff[columns_diff.name] = s2_diff;


	}
	fclose(fhighScoresDiff);

	}


	Gtk::TreeView::Column* pColumn = treeview_diff->get_column(1);
    if(pColumn)
    pColumn->set_sort_column(columns_diff.time);
    vbox->show_all();

    }

void mywindow4::on_notebook_switch_page(Gtk::Widget*  page , guint page_num)
{
std::cout << "Switched to tab with index " << page_num << std::endl;

}


mywindow6::mywindow6()
{
 set_modal(true);

show_all_children();
}


mywindow3::mywindow3()
{
     set_default_size(300, 300);
    set_title("Su-do-ku");
     set_modal(true);

    Gtk::Box *vbox = Gtk::manage(new Gtk::Box(Gtk::ORIENTATION_VERTICAL, 0));
    add(*vbox);

    Gtk::MenuBar *menubar = Gtk::manage(new Gtk::MenuBar());
    vbox->pack_start(*menubar, Gtk::PACK_SHRINK, 0);

    /*Gtk::MenuItem *menuitem_file = Gtk::manage(new Gtk::MenuItem("_File", true));
    menubar->append(*menuitem_file);
    Gtk::Menu *filemenu = Gtk::manage(new Gtk::Menu());
    menuitem_file->set_submenu(*filemenu);
    Gtk::MenuItem *menuitem_quit = Gtk::manage(new Gtk::MenuItem("_Quit", true));
    menuitem_quit->signal_activate().connect(sigc::mem_fun(*this, &mywindow3::on_quit_window3_click));
    filemenu->append(*menuitem_quit);
*/
    Gtk::Grid *grid = Gtk::manage(new Gtk::Grid);
    grid->set_border_width(10);
    //grid->set_column_spacing(100);
    //grid->set_row_spacing(100);
    vbox->add(*grid);
    Gtk::Label *l3= Gtk::manage(new Gtk::Label(" "));
    grid->attach(*l3, 0, 0, 1, 1);
    l3->set_hexpand(true);

    Gtk::Label *l1= Gtk::manage(new Gtk::Label("SELECT"));
    //l1->set_markup("<b>SELECT:/b>");
    grid->attach(*l1, 2, 0, 1, 1);
    l1->set_hexpand(true);

    Gtk::Label *l2= Gtk::manage(new Gtk::Label(" "));
    grid->attach(*l2, 4, 0, 1, 1);
    l2->set_hexpand(true);

    Gtk::Button *b1 = Gtk::manage(new Gtk::Button("EASY"));
    b1->signal_clicked().connect(sigc::mem_fun(*this, &mywindow3::on_easy_click));
    grid->attach(*b1, 2, 3, 1, 1);
    //b1->add(*b1label);
    b1->set_hexpand(true);



    Gtk::Label *l4= Gtk::manage(new Gtk::Label(" "));
    grid->attach(*l4, 0, 1, 1, 1);
    l4->set_hexpand(true);
    /*Gtk::Label *l5= Gtk::manage(new Gtk::Label(" "));
    grid->attach(*l5, 2, 1, 1, 1);
    l5->set_hexpand(true);*/
    Gtk::Label *l6= Gtk::manage(new Gtk::Label(" "));
    grid->attach(*l6, 0, 2, 1, 1);
    l6->set_hexpand(true);
    /*Gtk::Label *l7= Gtk::manage(new Gtk::Label(" "));
    grid->attach(*l7, 0, 3, 1, 1);
    l7->set_hexpand(true);*/
    //Gtk::Label *l6= Gtk::manage(new Gtk::Label(" "));
    //grid->attach(*l6, 4, 0, 1, 1);
    //l6->set_hexpand(true);
    Gtk::Label *l7= Gtk::manage(new Gtk::Label(" "));
    grid->attach(*l7, 0, 4, 1, 1);
    l7->set_hexpand(true);
    Gtk::Label *l8= Gtk::manage(new Gtk::Label(" "));
    grid->attach(*l8, 0, 6, 1, 1);
    l8->set_hexpand(true);
    Gtk::Label *l9= Gtk::manage(new Gtk::Label(" "));
    grid->attach(*l9, 0, 8, 1, 1);
    l9->set_hexpand(true);


    Gtk::Button *b2 = Gtk::manage(new Gtk::Button("MEDIUM"));
    b2->signal_clicked().connect(sigc::mem_fun(*this, &mywindow3::on_medium_click));
    grid->attach(*b2, 2, 5, 1, 1);

    Gtk::Button *b3 = Gtk::manage(new Gtk::Button("DIFFICULT"));
    b3->signal_clicked().connect(sigc::mem_fun(*this, &mywindow3::on_difficult_click));
    grid->attach(*b3, 2, 7, 1, 1);

    vbox->show_all();


    show_all_children();
}

void mywindow3::on_easy_click()
{
mypopup *popup = new mypopup;
    popup->popup = new mywindow6;
    popup->windowid = window3cnt1;
    popup->popup->operate_easy();

    std::stringstream ss;
    ss << "EASY SUDOKU" << window3cnt1 << "'";
   // popup->popup->set_title(ss.str());
   // popup->popup->signal_hide().connect(sigc::bind<mypopup*>(sigc::mem_fun(*this, &mywindow3::on_popup_close), popup));

    popups[window3cnt1] = popup;
    window3cnt1++;

    popup->popup->show();
}

void mywindow6::operate_easy()
{    set_default_size(200, 200);
     set_border_width(10);

     sudoku4=new int *[9];
     if(sudoku4==NULL){std::cout<<"MEMORY ALLOCATION FAILURE";}
     for(int k=0;k<9;k++){ sudoku4[k]= new int[9];
                            if (sudoku4[k]==NULL){std::cout<<"MEMORY ALLOCATION FAILURE";}}

    /* for (int l=0;l<9;l++){
            for(int m=0;m<9;m++){ sudoku4[l][m]=0;}}*/

    read_sud('e',sudoku4);
    sudoku4_1=new int *[9];
    if(sudoku4_1==NULL){std::cout<<"MEMORY ALLOCATION FAILURE";}
    for(int k=0;k<9;k++){ sudoku4_1[k]= new int[9];
                            if (sudoku4_1[k]==NULL){std::cout<<"MEMORY ALLOCATION FAILURE";}}

    for(int a=0; a<9;a++) {
    for(int b=0; b<9 ;b++){sudoku4_1[a][b]=sudoku4[a][b]; }
    //sudoku_solver(sudoku4_1);
    Gtk::Button ***buttons_6;
    buttons_6=new Gtk::Button **[9];
    for(int k=0;k<9;k++){ buttons_6[k]= new Gtk::Button*[9];}


    //Gtk::Box *vbox = Gtk::manage(new Gtk::Box(Gtk::ORIENTATION_VERTICAL, 0));
    //add(*vbox);

    Gtk::Grid *grid = Gtk::manage(new Gtk::Grid);
    grid->set_border_width(40);
    //vbox->add(*grid);
    add(*grid);

 //std::string buttonIdStr[9][9];
    for(int i=0; i<9;i++) {
    for(int j=0; j<9 ;j++){
    char temp='0' + sudoku4[i][j];
    std::stringstream ss;
    ss<<temp;
    std::string buttonIdStr=ss.str();
    buttons_6[i][j]=Gtk::manage(new Gtk::Button(buttonIdStr));


      if(sudoku4[i][j]==0)
      {buttons_6[i][j]->signal_clicked().connect(sigc::bind<int,int,int** , Gtk::Button*>(sigc::mem_fun(*this, &mywindow6::on_button_6_click),i,j,sudoku4,buttons_6[i][j]));}

      grid->attach(*buttons_6[i][j],i,j,1,1);




     }
     }

     Gtk::Button *solve_6=Gtk::manage(new Gtk::Button("Solve"));
     grid->attach(*solve_6,5,13,3,3);

     Gtk::Button *check=Gtk::manage(new Gtk::Button("Check"));
     grid->attach(*check,1,13,3,3);
     std::clock_t start;
     start=std::clock();


     solve_6->signal_clicked().connect(sigc::bind<int**,int** >(sigc::mem_fun(*this, &mywindow6::on_solve_6_click),sudoku4,sudoku4_1));

     check->signal_clicked().connect(sigc::bind<int**,int**, Gtk::Button*** ,Gtk::Grid* ,std::clock_t>(sigc::mem_fun(*this, &mywindow6::on_check_click),sudoku4,sudoku4_1,buttons_6,grid,start));

     grid->show_all();
     show_all_children();


}
}


int mywindow6::read_sud(char level,int **sudoku4){
    FILE *fin;


    struct read_sudoku{int get_sudoku[81];};
    read_sudoku temp;
    //char level;
    int i,j,k;
    int index= rand() %15 +1;
    //std::cout<<index;
    //index=random15;
    int size_bin=sizeof(struct read_sudoku);
    cout<<"enter the level:d for difficult"<<endl;
    cout<<"                m for medium"<<endl;
    cout<<"                e for easy"<<endl;
   // cin>>level;
    cout<<"enter the index num of puzzle"<<endl;
   // cin>>index;
    cout<<"------------------------------------------------"<<endl;
    if(level=='d') fin=fopen("sudoku(d)","rb");
    if(level=='m') fin=fopen("sudoku(m)","rb");
    if(level=='e') fin=fopen("sudoku(e)","rb");
    if(fin==NULL){cout<<"error reading the binary file"<<endl;
                  return -1;}
    fseek(fin,(index-1)*size_bin,SEEK_SET);
    fread(&temp,size_bin,1,fin);
    for(i=0,k=0;i<9;i++){
        for(j=0;j<9;j++){
            sudoku4[i][j]=temp.get_sudoku[k++]-'0';
        }
    }
   /* for(i=0;i<9;i++){
        for(j=0;j<9;j++){
           cout<<upload[i][j]<<" ";
        }*/
   // cout<<endl;}
    fclose(fin);
    return 0;
}

void mywindow6::on_button_6_click(int i,int j,int **sudoku3, Gtk::Button *button_6)
{
        button_6_mypopup *popup = new button_6_mypopup;
        popup->popup = new mywindow7;
        popup->windowid = win7cnt;
        popup->popup->operate_7(i,j,sudoku3,button_6);

        std::stringstream ss;
        ss << "Enter Number" << win7cnt << "'";
        popup->popup->set_title(ss.str());
        // popup->popup->signal_hide().connect(sigc::bind<high_scores_mypopup*>(sigc::mem_fun(*this, &mywindow::on_high_scores_popup_close), popup));

        // popups[windowcnt3] = popup;
        win7cnt++;

        popup->popup->show();

}

void mywindow6::on_solve_6_click(int **sudoku4, int **sudoku4_1 )
{
        solver_6_mypopup *popup= new solver_6_mypopup;
        popup->popup = new mywindow8;
        popup->windowid = win8cnt;
        sudoku_solver(sudoku4_1);
        popup->popup->operate_8(sudoku4,sudoku4_1);

        std::stringstream ss;
        ss << "SOLUTION" << win8cnt << "'";
        popup->popup->set_title(ss.str());

        win8cnt++;

        popup->popup->show();


  //{Gtk::MessageDialog dlg("INVALID SUDOKU", false, Gtk::MESSAGE_ERROR, Gtk::BUTTONS_OK, true);
    //                                dlg.set_title("INVALID");
      //                              dlg.run();}
        /*for(int x=0;x<9;x++){
        for(int y=0;y<9;y++){
                    std::stringstream ss;
                    ss<<sudoku3[x][y];
                    buttons_6[x][y]->set_label(ss.str());
                    }
                    }
                    }*/
}

void mywindow6::on_check_click(int **sudoku4, int **sudoku4_1, Gtk::Button ***buttons_6 ,Gtk::Grid* grid,std::clock_t &start)
{
    sudoku_solver(sudoku4_1);
    bool flag;

for(int a;a<9;a++)
{   for(int b;b<9;b++){
                        if(sudoku4[a][b]!=sudoku4_1[a][b])
                            {
                                char temp='0' + sudoku4[a][b];
                                std::stringstream ss1;
                                ss1<<temp;
                                std::string buttonIdStr=ss1.str();
                                Gtk::Label *buttonlabel =Gtk::manage(new Gtk::Label);
                                buttonlabel->set_markup("<span color='red'>F</span>");
                                //buttons_6[a][b]->set_label("F");
                                buttons_6[a][b]->add(*buttonlabel);
                                //grid->attach(*buttons_6[a][b],a,b,1,1);
                                flag=false;

                                    }

                        }}
                        if(flag==false) {    Gtk::MessageDialog dlg("INCORRECT SUDOKU", false, Gtk::MESSAGE_ERROR, Gtk::BUTTONS_OK, true);
                                dlg.set_title("INVALID");
                                dlg.run();}
                        else{Gtk::MessageDialog dlg1("CONGRATS!You solved it!", false, Gtk::MESSAGE_INFO, Gtk::BUTTONS_OK, true);
                                dlg1.set_title("CORRECT");
                                dlg1.run();
                                }

                                double duration;
                                duration=(std::clock()-start)/(double) CLOCKS_PER_SEC;
                                std::cout<<duration<<std::endl;
}




/*mywindow8::operate_8(int i,int j,int** sudoku2,Gtk::Button* button)
{
    set_default_size(100, 50);
    Gtk::Box *vbox = Gtk::manage(new Gtk::Box(Gtk::ORIENTATION_VERTICAL, 0));
    add(*vbox);

    Gtk::Grid *grid = Gtk::manage(new Gtk::Grid);
    grid->set_border_width(10);
    vbox->add(*grid);

    /*Gtk::Label *label2 = Gtk::manage(new Gtk::Label(" "));
    grid->attach(*label2,0,0,1,1);
    add(*label2);
    label2->set_hexpand(true);*/

  //  Gtk::Label *label1 = Gtk::manage(new Gtk::Label("Enter Number:"));
    //grid->attach(*label1,1,0,1,1);
    //add(*label1);
    //label1->set_hexpand(true);

   /* Gtk::Label *label3 = Gtk::manage(new Gtk::Label(" "));
    grid->attach(*label3,2,0,1,1);
    add(*label3);
    label3->set_hexpand(true);*/
   // Gtk::Entry *entry=  Gtk::manage(new Gtk::Entry());

   // grid->attach(*entry, 1, 1, 1, 1);

   // Gtk::Button *button_ok= Gtk::manage(new Gtk::Button("OK"));
  //  grid->attach(*button_ok,1,2,1,1);
    //vbox->add(*button_ok);
  //  button_ok->signal_clicked().connect(sigc::bind<int , int,int**,Gtk::Entry* ,Gtk::Button* >(sigc::mem_fun(*this, &mywindow8::on_button_ok_6_click),i,j,sudoku3,entry,button));



    //show_all_children();


mywindow8::mywindow8(){
 set_modal(true);

}

void mywindow8::operate_8(int **sudoku4,int **sudoku4_1)
{
    set_default_size(500, 500);
    set_title("SOLUTION");
    set_border_width(15);

    Gtk::Box *vbox = Gtk::manage(new Gtk::Box(Gtk::ORIENTATION_VERTICAL, 0));
    add(*vbox);

    Gtk::Grid *grid = Gtk::manage(new Gtk::Grid);
    grid->set_border_width(40);
    vbox->add(*grid);

    Gtk::Button ***buttons_8_1;
    buttons_8_1=new Gtk::Button **[9];
    for(int k=0;k<9;k++){ buttons_8_1[k]= new Gtk::Button*[9];}

    Gtk::Button ***buttons_8_2;
    buttons_8_2=new Gtk::Button **[9];
    for(int k=0;k<9;k++){ buttons_8_2[k]= new Gtk::Button*[9];}

    for(int i=0; i<9;i++) {
    for(int j=0; j<9 ;j++){
    char temp1='0' + sudoku4[i][j];
    std::stringstream ss1;
    ss1<<temp1;
    std::string buttonIdStr=ss1.str();
    buttons_8_1[i][j]=Gtk::manage(new Gtk::Button(buttonIdStr));


      //if(sudoku4[i][j]==0)
      //{buttons_8_1[i][j]->signal_clicked().connect(sigc::bind<int,int,int** , Gtk::Button*>(sigc::mem_fun(*this, &mywindow6::on_button_6_click),i,j,sudoku4,buttons_6[i][j]));}

      grid->attach(*buttons_8_1[i][j],i+4,j,1,1);

      char temp2= '0' + sudoku4_1[i][j];
      std::stringstream ss2;
      ss2<<temp2;
      buttonIdStr=ss2.str();
      buttons_8_2[i][j]=Gtk::manage(new Gtk::Button(buttonIdStr));
      grid->attach(*buttons_8_2[i][j],i+15,j,1,1);
        }
    }

    Gtk::Label *empty= Gtk::manage(new Gtk::Label("                              "));
    grid->attach(*empty, 14, 0, 1, 1);

    Gtk::Label *sub= Gtk::manage(new Gtk::Label("SUBMITTED SUDOKU                                                            SOLUTION"));
    //grid->attach(*sub, 3, 12, 1, 1);
    vbox->add(*sub);


    //Gtk::Label *sol= Gtk::manage(new Gtk::Label("SOLUTION"));
    //grid->attach(*sol, 14, 2, 1, 1);
    //vbox->add(*sol);

    show_all_children();

}


void mywindow3::on_medium_click()
{
    mypopup *popup = new mypopup;
    popup->popup = new mywindow6;
    popup->windowid = window3cnt2;
    popup->popup->operate_medium();
    std::stringstream ss;
    ss << "MEDIUM SUDOKU" << window3cnt2 << "'";
    popup->popup->set_title(ss.str());
    popup->popup->signal_hide().connect(sigc::bind<mypopup*>(sigc::mem_fun(*this, &mywindow3::on_popup_close), popup));

    popups[window3cnt2] = popup;
    window3cnt2++;

    popup->popup->show();
}
void mywindow6::operate_medium()
{
    set_default_size(200, 200);
    set_title("MEDIUM SUDOKU");
    set_border_width(10);
    sudoku5=new int *[9];
     if(sudoku5==NULL){std::cout<<"MEMORY ALLOCATION FAILURE";}
     for(int k=0;k<9;k++){ sudoku5[k]= new int[9];
                            if (sudoku5[k]==NULL){std::cout<<"MEMORY ALLOCATION FAILURE";}}
     for (int l=0;l<9;l++){
            for(int m=0;m<9;m++){ sudoku5[l][m]=0;}}

    read_sud('m',sudoku5);
    sudoku5_1=new int *[9];
    if(sudoku5_1==NULL){std::cout<<"MEMORY ALLOCATION FAILURE";}
    for(int k=0;k<9;k++){ sudoku5_1[k]= new int[9];
                            if (sudoku5_1[k]==NULL){std::cout<<"MEMORY ALLOCATION FAILURE";}}

    for(int a=0; a<9;a++) {
    for(int b=0; b<9 ;b++){sudoku5_1[a][b]=sudoku5[a][b]; }
    Gtk::Button ***buttons_6;
    buttons_6=new Gtk::Button **[9];
    for(int k=0;k<9;k++){ buttons_6[k]= new Gtk::Button*[9];}


    Gtk::Box *vbox = Gtk::manage(new Gtk::Box(Gtk::ORIENTATION_VERTICAL, 0));
    add(*vbox);

    Gtk::Grid *grid = Gtk::manage(new Gtk::Grid);
    grid->set_border_width(40);
    vbox->add(*grid);

    std::string buttonIdStr[9][9];
    for(int i=0; i<9;i++) {
    for(int j=0; j<9 ;j++){
     char temp='0' + sudoku5[i][j];
     std::stringstream ss;
     ss<<temp;
     std::string buttonIdStr=ss.str();
     buttons_6[i][j]=Gtk::manage(new Gtk::Button(buttonIdStr));


      if(sudoku5[i][j]==0)
      {buttons_6[i][j]->signal_clicked().connect(sigc::bind<int,int,int** , Gtk::Button*>(sigc::mem_fun(*this, &mywindow6::on_button_6_click),i,j,sudoku5,buttons_6[i][j]));}

      grid->attach(*buttons_6[i][j],i,j,1,1);




     }
     }

     Gtk::Button *solve_6=Gtk::manage(new Gtk::Button("Solve"));
     grid->attach(*solve_6,5,13,3,3);

     Gtk::Button *check=Gtk::manage(new Gtk::Button("Check"));
     grid->attach(*check,1,13,3,3);

     std::clock_t start;
     start=std::clock();



     solve_6->signal_clicked().connect(sigc::bind<int**, int** >(sigc::mem_fun(*this, &mywindow6::on_solve_6_click),sudoku5,sudoku5_1));
     check->signal_clicked().connect(sigc::bind<int**,int**, Gtk::Button*** ,Gtk::Grid* , std::clock_t >(sigc::mem_fun(*this, &mywindow6::on_check_click),sudoku5,sudoku5_1,buttons_6,grid,start));

     show_all_children();

}
}



void mywindow3::on_difficult_click()
{
mypopup *popup = new mypopup;
    popup->popup = new mywindow6;
    popup->windowid = window3cnt3;
    popup->popup->operate_difficult();

    std::stringstream ss;
    ss << "DIFFICULT SUDOKU" << window3cnt3 << "'";
    popup->popup->set_title(ss.str());
    popup->popup->signal_hide().connect(sigc::bind<mypopup*>(sigc::mem_fun(*this, &mywindow3::on_popup_close), popup));

    popups[window3cnt3] = popup;
    window3cnt3++;

    popup->popup->show();
}

void mywindow6::operate_difficult()
{
    set_default_size(200, 200);
    set_border_width(10);
     sudoku6=new int *[9];
     if(sudoku6==NULL){std::cout<<"MEMORY ALLOCATION FAILURE";}
     for(int k=0;k<9;k++){ sudoku6[k]= new int[9];
                            if (sudoku6[k]==NULL){std::cout<<"MEMORY ALLOCATION FAILURE";}}
     for (int l=0;l<9;l++){
            for(int m=0;m<9;m++){ sudoku6[l][m]=0;}}

    read_sud('d',sudoku6);
    sudoku6_1=new int *[9];
    if(sudoku6_1==NULL){std::cout<<"MEMORY ALLOCATION FAILURE";}
    for(int k=0;k<9;k++){ sudoku6_1[k]= new int[9];
                            if (sudoku6_1[k]==NULL){std::cout<<"MEMORY ALLOCATION FAILURE";}}

    for(int a=0; a<9;a++) {
    for(int b=0; b<9 ;b++){sudoku6_1[a][b]=sudoku6[a][b]; }

    Gtk::Button ***buttons_6;
    buttons_6=new Gtk::Button **[9];
    for(int k=0;k<9;k++){ buttons_6[k]= new Gtk::Button*[9];}


    Gtk::Box *vbox = Gtk::manage(new Gtk::Box(Gtk::ORIENTATION_VERTICAL, 0));
    add(*vbox);

    Gtk::Grid *grid = Gtk::manage(new Gtk::Grid);
    grid->set_border_width(40);
    vbox->add(*grid);

 //std::string buttonIdStr[9][9];
    for(int i=0; i<9;i++) {
    for(int j=0; j<9 ;j++){
     char temp='0' + sudoku6[i][j];
     std::stringstream ss;
     ss<<temp;
     std::string buttonIdStr=ss.str();
     buttons_6[i][j]=Gtk::manage(new Gtk::Button(buttonIdStr));


      if(sudoku6[i][j]==0)
      {buttons_6[i][j]->signal_clicked().connect(sigc::bind<int,int,int** , Gtk::Button*>(sigc::mem_fun(*this, &mywindow6::on_button_6_click),i,j,sudoku6,buttons_6[i][j]));}

      grid->attach(*buttons_6[i][j],i,j,1,1);




     }
     }

     Gtk::Button *solve_6=Gtk::manage(new Gtk::Button("Solve"));
     grid->attach(*solve_6,5,13,3,3);

     Gtk::Button *check=Gtk::manage(new Gtk::Button("Check"));
     grid->attach(*check,1,13,3,3);

      std::clock_t start;
     start=std::clock();



     solve_6->signal_clicked().connect(sigc::bind<int**,int** >(sigc::mem_fun(*this, &mywindow6::on_solve_6_click),sudoku6,sudoku6_1));
     check->signal_clicked().connect(sigc::bind<int**,int**, Gtk::Button*** ,Gtk::Grid*,std::clock_t >(sigc::mem_fun(*this, &mywindow6::on_check_click),sudoku6,sudoku6_1,buttons_6,grid,start));

     show_all_children();

}

}

void mywindow2::on_button_click(int i,int j,int** sudoku2,Gtk::Button* button)

{

    button_mypopup *popup = new button_mypopup;
    popup->popup = new mywindow7;
    popup->windowid = window7cnt;
    popup->popup->operate_7(i,j,sudoku2,button);
    //mywindow7::row=i;
    //mywindow7::column=j;

    std::stringstream ss;
    ss << "Enter Number" << window7cnt << "'";
    popup->popup->set_title(ss.str());
   // popup->popup->signal_hide().connect(sigc::bind<high_scores_mypopup*>(sigc::mem_fun(*this, &mywindow::on_high_scores_popup_close), popup));

   // popups[windowcnt3] = popup;
    window7cnt++;

    popup->popup->show();

}

mywindow7::mywindow7()
{
    set_modal(true);
    /*set_default_size(100, 50);
    Gtk::Box *vbox = Gtk::manage(new Gtk::Box(Gtk::ORIENTATION_VERTICAL, 0));
    add(*vbox);

    Gtk::Grid *grid = Gtk::manage(new Gtk::Grid);
    grid->set_border_width(10);
    vbox->add(*grid);

    Gtk::Label *label2 = Gtk::manage(new Gtk::Label(" "));
    grid->attach(*label2,0,0,1,1);
    add(*label2);
    label2->set_hexpand(true);

    Gtk::Label *label1 = Gtk::manage(new Gtk::Label("Enter Number:"));
    grid->attach(*label1,1,0,1,1);
    add(*label1);
    label1->set_hexpand(true);

    Gtk::Label *label3 = Gtk::manage(new Gtk::Label(" "));
    grid->attach(*label3,2,0,1,1);
    add(*label3);
    label3->set_hexpand(true);
    Gtk::Entry *entry=  Gtk::manage(new Gtk::Entry());

    grid->attach(*entry, 1, 1, 1, 1);

    Gtk::Button *button_ok= Gtk::manage(new Gtk::Button("OK"));
    grid->attach(*button_ok,1,2,1,1);
    vbox->add(*button_ok);
    button_ok->signal_clicked().connect(sigc::mem_fun(*this, &mywindow7::on_button_ok_click));



    show_all_children();*/
}

void mywindow7::operate_7(int i,int j,int** sudoku2,Gtk::Button* button)
{

    set_default_size(100, 50);
    Gtk::Box *vbox = Gtk::manage(new Gtk::Box(Gtk::ORIENTATION_VERTICAL, 0));
    add(*vbox);

    Gtk::Grid *grid = Gtk::manage(new Gtk::Grid);
    grid->set_border_width(10);
    vbox->add(*grid);

    /*Gtk::Label *label2 = Gtk::manage(new Gtk::Label(" "));
    grid->attach(*label2,0,0,1,1);
    add(*label2);
    label2->set_hexpand(true);*/

    Gtk::Label *label1 = Gtk::manage(new Gtk::Label("Enter Number:"));
    grid->attach(*label1,1,0,1,1);
    //add(*label1);
    //label1->set_hexpand(true);

   /* Gtk::Label *label3 = Gtk::manage(new Gtk::Label(" "));
    grid->attach(*label3,2,0,1,1);
    add(*label3);
    label3->set_hexpand(true);*/
    Gtk::Entry *entry=  Gtk::manage(new Gtk::Entry());
    entry->set_max_length(1);

    grid->attach(*entry, 1, 1, 1, 1);

    Gtk::Button *button_ok= Gtk::manage(new Gtk::Button("OK"));
    grid->attach(*button_ok,1,2,1,1);
    //vbox->add(*button_ok);
    button_ok->signal_clicked().connect(sigc::bind<int , int,int**,Gtk::Entry* ,Gtk::Button* >(sigc::mem_fun(*this, &mywindow7::on_button_ok_click),i,j,sudoku2,entry,button));



    show_all_children();
}
void mywindow7::on_button_ok_click(int i,int j,int** sudoku2,Gtk::Entry* entry,Gtk::Button* button){

std::string buttonIdStr=entry->get_text();
//float buttonIdStr=entry->get_text();
char temp=buttonIdStr[0];
float sudoku_value;
sscanf(&temp,"%f",&sudoku_value);
if(sudoku_value==0||sudoku_value==1||sudoku_value==2||sudoku_value==3||sudoku_value==4||sudoku_value==5||
 sudoku_value==6||sudoku_value==7||sudoku_value==8||sudoku_value==9){sudoku2[i][j]=sudoku_value;
                                                                    button->set_label(buttonIdStr);}
else{
     Gtk::MessageDialog dlg("Enter Valid Number", false, Gtk::MESSAGE_ERROR, Gtk::BUTTONS_OK, true);
                                                                      dlg.set_title("INVALID");
                                                                      dlg.run();}
hide();

}
 void mywindow2::on_button_popup_close(button_mypopup *popup)
 {
    std::stringstream ss;

    ss << "Deleting Window '" << popup->windowid << "'";
    std::cout << ss.str() << std::endl;

    popups.erase(popup->windowid);
    delete popup->popup;
    delete popup;}



void mywindow3::on_popup_close(mypopup *popup)
{
    std::stringstream ss;

    ss << "Deleting Window '" << popup->windowid << "'";
    std::cout << ss.str() << std::endl;

    popups.erase(popup->windowid);
    delete popup->popup;
    delete popup;
}

mywindow8::~mywindow8()
{

}
mywindow7::~mywindow7()
{

}



mywindow6::~mywindow6()
{
    //dtor
}
mywindow4::~mywindow4()
{
    //dtor
}

mywindow3::~mywindow3()
{     std::map<int, mypopup*>::iterator iter;
    for (iter = popups.begin(); iter != popups.end(); iter++)
    {
        mypopup *popup = iter->second;

        std::stringstream ss;
        ss << "Deleting Window '" << iter->first << "'";
        std::cout << ss.str() << std::endl;

        delete popup->popup;
        //delete popup->popup3;
        delete popup;
    }   //dtor
    /*std::map<int, easy_mypopup*>::iterator iter;
    for (iter = popups.begin(); iter != popups.end(); iter++)
    {
        button_mypopup *popup = iter->second;

        std::stringstream ss;
        ss << "Deleting Window '" << iter->first << "'";
        std::cout << ss.str() << std::endl;

        delete popup->popup;
        //delete popup->popup3;
        delete popup;
    }   //dtor
    std::map<int, medium_mypopup*>::iterator iter1;
    for (iter1 = popups.begin(); iter1 != popups.end(); iter++)
    {
        button_mypopup *popup = iter1->second;

        std::stringstream ss1;
        ss1 << "Deleting Window '" << iter1->first << "'";
        std::cout << ss1.str() << std::endl;

        delete popup->popup;
        //delete popup->popup3;
        delete popup;
    }   //dtor
    std::map<int, difficult_mypopup*>::iterator iter2;
    for (iter2 = popups.begin(); iter2 != popups.end(); iter2++)
    {
        button_mypopup *popup = iter2->second;

        std::stringstream ss2;
        ss2 << "Deleting Window '" << iter2->first << "'";
        std::cout << ss2.str() << std::endl;

        delete popup->popup;
        //delete popup->popup3;
        delete popup;
    }   //dtor*/
}

mywindow2::~mywindow2()
{
 std::map<int, button_mypopup*>::iterator iter;
    for (iter = popups.begin(); iter != popups.end(); iter++)
    {
        button_mypopup *popup = iter->second;

        std::stringstream ss;
        ss << "Deleting Window '" << iter->first << "'";
        std::cout << ss.str() << std::endl;

        //if(&)delete
        for(int z=0;z<10;z++){
        if(sudoku2[z]!=NULL){delete[] sudoku2[z];
        }
        else std::cout<<"MEMORY DELETION FAILURE";
        }

        if(sudoku2!=NULL){delete sudoku2;}
        else std::cout<<"MEMORY DELETION FAILURE";



        delete popup->popup;
        //delete popup->popup3;
        delete popup;
    }   //dtor
}
void mywindow3::on_quit_window3_click()
{
    hide();
}

void mywindow::on_quit_window1_click()
{
    hide();
}




//#include <gtkmm.h>
//#include "mywindow.h"

int main(int argc, char *argv[])
{
    Glib::RefPtr<Gtk::Application> app = Gtk::Application::create(argc, argv, "com.gtkmm.tutorial3.base");

    mywindow window;

    return app->run(window);
}

/* SUDOKU SOLVER STARTS HERE */
/* ========================== */






/*void possibility(int A[9][9][10]);
void pos_unassigned(int A[9][9][10],int add_unassigned[81][2]);
bool backtrack(int A[9][9][10],int pos_unassgn[][2],int j);
bool check_valid(int A[9][9][10],int row,int column,int value);
int **sudoku_solver(int** A);*/

bool mywindow2::sudoku_solver(int** sudoku2)
{   int sudoku[9][9][10];
    int add_unassigned[81][2];

    for(int n=0;n<9;n++){

            for(int o=0;o<9;o++){ sudoku[n][o][0]=sudoku2[n][o];}}

    cout<<"||Sudoku Solver||"<<endl;
    cout<<"Enter 81 numbers(b/w 1&9) space separated values"<<endl;
    cout<<"enter 0 otherwise"<<endl;
   /* for(i=0;i<9;i++)
    {
        for(j=0;j<9;j++)
        {
            cin>>sudoku[i][j][0];
        }
    }*/
    //for(i=0;i<9;i++)
    //{
    //    for(j=0;j<9;j++)
    //    {
    //        sudoku[i][j][0]=0;
    //    }
    //}

    cout<<endl;

       //check if sudoku is valid or invalid

    for(int x;x<9;x++){
    for(int y;y<9;y++){if(sudoku[x][y][0]!=0){if(check_valid(sudoku,x,y,sudoku[x][y][0])==false){cout<<"Invalid Sudoku";return false;} } } }


    pos_unassigned(sudoku,add_unassigned);

    possibility(sudoku);
    if(!backtrack(sudoku,add_unassigned,0)){cout<<"Invalid Sudoku!";
                                            return false;}
    /* for(i=0;i<9;i++)
    {
        for(j=0;j<9;j++)
        {
            cout<<sudoku[i][j][0]<<" ";
            if(j==8){cout<<endl;}
        }
    }*/

    for(int n=0;n<9;n++){

            for(int o=0;o<9;o++){ sudoku2[n][o]=sudoku[n][o][0];}}

    return true;
}

void mywindow2::possibility(int A[9][9][10])
{
    for(int i=0;i<9;i++)
    {
        for(int j=0;j<9;j++)
        {
            if(A[i][j][0]==0)
            {
                for(int k=1;k<=9;k++)
                {
                    if(check_valid(A,i,j,k)==false)
                    {
                        A[i][j][k]=0;
                    }
                    else
                    {
                        A[i][j][k]=1;
                    }
                }
            }
        }
    }
    return;
}


void mywindow2::pos_unassigned(int A[9][9][10],int add_unassigned[81][2])
{
    int i,j,k=0;



    for(i=0;i<81;i++)
    {
        for(j=0;j<2;j++)
        {
            add_unassigned[i][j]=-1;
        }
    }
    for(i=0;i<9;i++)
    {
        for(j=0;j<9;j++)
        {
            if(A[i][j][0]==0)

                { add_unassigned[k][0]=i;
                  add_unassigned[k][1]=j;
                  k++;
            }
            /*else
            {
                continue;
            }*/
        }
    }
    return ;
}

bool mywindow2::backtrack(int A[9][9][10],int pos_unassgn[81][2],int j){

if ((pos_unassgn[j][0]==-1)||(j==81)){return true;}//End of recursion

int row=pos_unassgn[j][0];
int col=pos_unassgn[j][1];

for(int i=1;i<10;i++){
    if (A[row][col][i]==1){
    if ( check_valid(A,row,col,i)){ A[row][col][0]=i;
                                                if((backtrack(A,pos_unassgn,j+1))){return true;
                                                                                            }

                                                else { A[row][col][0]=0;
                                                        continue;}
                                                }
    //  else {A[row][col][i]==0;}         //  CHECK IT PLEASE NOT SURE
                                 }

                }
    return false;

}

bool mywindow2::check_valid(int A[9][9][10],int row,int column,int value)
{
    int l,m;

    for(l=0;l<9;l++){

        if(l!=row){if(A[l][column][0]==value){return false;}
                    }

                }

    for(m=0;m<9;m++){

       if(m!=column) {if(A[row][m][0]==value){return false;}
                    }
      }

    for(l=(row/3)*3;l<(row/3)*3+3;l++) {

        for(m=(column/3)*3;m<(column/3)*3+3;m++){
                                   if ((l!=row)||(m!=column)){
                                                               if (A[l][m][0]==value){return false;}

                                                                }

                                    }
    }

   return true;

    }



    bool mywindow6::sudoku_solver(int** sudoku2)
{   int sudoku[9][9][10];
    int add_unassigned[81][2];

    for(int n=0;n<9;n++){

            for(int o=0;o<9;o++){ sudoku[n][o][0]=sudoku2[n][o];}}

    /*cout<<"||Sudoku Solver||"<<endl;
    cout<<"Enter 81 numbers(b/w 1&9) space separated values"<<endl;
    cout<<"enter 0 otherwise"<<endl;*/
   /* for(i=0;i<9;i++)
    {
        for(j=0;j<9;j++)
        {
            cin>>sudoku[i][j][0];
        }
    }*/
    //for(i=0;i<9;i++)
    //{
    //    for(j=0;j<9;j++)
    //    {
    //        sudoku[i][j][0]=0;
    //    }
    //}

    cout<<endl;

       //check if sudoku is valid or invalid

    for(int x;x<9;x++){
    for(int y;y<9;y++){if(sudoku[x][y][0]!=0){if(check_valid(sudoku,x,y,sudoku[x][y][0])==false){cout<<"Invalid Sudoku";return false;} } } }


    pos_unassigned(sudoku,add_unassigned);

    possibility(sudoku);
    if(!backtrack(sudoku,add_unassigned,0)){cout<<"Are you kidding? This sudoku is invalid!";
                                            return false;};
    /* for(i=0;i<9;i++)
    {
        for(j=0;j<9;j++)
        {
            cout<<sudoku[i][j][0]<<" ";
            if(j==8){cout<<endl;}
        }
    }*/

    for(int n=0;n<9;n++){

            for(int o=0;o<9;o++){ sudoku2[n][o]=sudoku[n][o][0];}}

    return true ;
}

void mywindow6::possibility(int A[9][9][10])
{
    for(int i=0;i<9;i++)
    {
        for(int j=0;j<9;j++)
        {
            if(A[i][j][0]==0)
            {
                for(int k=1;k<=9;k++)
                {
                    if(check_valid(A,i,j,k)==false)
                    {
                        A[i][j][k]=0;
                    }
                    else
                    {
                        A[i][j][k]=1;
                    }
                }
            }
        }
    }
    return ;
}


void mywindow6::pos_unassigned(int A[9][9][10],int add_unassigned[81][2])
{
    int i,j,k=0;



    for(i=0;i<81;i++)
    {
        for(j=0;j<2;j++)
        {
            add_unassigned[i][j]=-1;
        }
    }
    for(i=0;i<9;i++)
    {
        for(j=0;j<9;j++)
        {
            if(A[i][j][0]==0)

                { add_unassigned[k][0]=i;
                  add_unassigned[k][1]=j;
                  k++;
            }
            /*else
            {
                continue;
            }*/
        }
    }
    return ;
}

bool mywindow6::backtrack(int A[9][9][10],int pos_unassgn[81][2],int j){

if ((pos_unassgn[j][0]==-1)||(j==81)){return true;}//End of recursion

int row=pos_unassgn[j][0];
int col=pos_unassgn[j][1];

for(int i=1;i<10;i++){
    if (A[row][col][i]==1){
    if ( check_valid(A,row,col,i)){ A[row][col][0]=i;
                                                if((backtrack(A,pos_unassgn,j+1))){return true;
                                                                                            }

                                                else { A[row][col][0]=0;
                                                        continue;}
                                                }
    //  else {A[row][col][i]==0;}         //  CHECK IT PLEASE NOT SURE
                                 }

                }
    return false;

}

bool mywindow6::check_valid(int A[9][9][10],int row,int column,int value)
{
    int l,m;

    for(l=0;l<9;l++){

        if(l!=row){if(A[l][column][0]==value){return false;}
                    }

                }

    for(m=0;m<9;m++){

       if(m!=column) {if(A[row][m][0]==value){return false;}
                    }
      }

    for(l=(row/3)*3;l<(row/3)*3+3;l++) {

        for(m=(column/3)*3;m<(column/3)*3+3;m++){
                                   if ((l!=row)||(m!=column)){
                                                               if (A[l][m][0]==value){return false;}

                                                                }

                                    }
    }

   return true;

    }



