//#ifndef MYWINDOW_H
//#define MYWINDOW_H
#ifndef MYWINDOW_H
#define MYWINDOW_H

#include "mywindow3.h"
#include "solver_screen.h"
#include "mywindow6.h"
#include "mywindow4.h"
#include "mywindow7.h"
#include <gtkmm.h>

class mywindow : public Gtk::Window
{
    public:
        mywindow();
        virtual ~mywindow();
    protected:
       /*id on_button2_click();
        void on_button3_click();
        void on_quit_click();
        void dialog(Glib::ustring msg);*/
    private:
        int windowcnt1 = 0;
        int windowcnt2 = 0;
        int windowcnt3 = 0;



        struct new_game_mypopup
        {
            int windowid;
            mywindow3 *popup;

          };
         struct sudoku_solver_mypopup
        {
            int windowid;
            mywindow2 *popup;

        };
        struct high_scores_mypopup
        {
            int windowid;
            mywindow4 *popup;

        };

        void on_new_game_click();
        void on_sudoku_solver_click();
        void on_high_scores_click();
        void on_quit_window1_click();
        void dialog(Glib::ustring msg);
        void on_new_game_popup_close(new_game_mypopup *popup);
        void on_sudoku_solver_popup_close(sudoku_solver_mypopup *popup);
        void on_high_scores_popup_close(high_scores_mypopup *popup);
            std::map<int, new_game_mypopup*> popups;
            std::map<int, sudoku_solver_mypopup*> popups1;
            std::map<int, high_scores_mypopup*> popups2;
};
#endif // MYWINDOW_H
