#ifndef MYWINDOW6_H
#define MYWINDOW6_H

#include <gtkmm.h>
#include "mywindow7.h"
#include "mywindow8.h"

class mywindow6 : public Gtk::Window
{
    public:
        mywindow6();
        virtual ~mywindow6();

        void operate_easy();
        void operate_medium();
        void operate_difficult();


    protected:
    private:
    int win7cnt;
    int win8cnt;
    int **sudoku4;
    int **sudoku4_1;
    int **sudoku5;
    int **sudoku5_1;
    int **sudoku6;
    int **sudoku6_1;
    struct button_6_mypopup
        {
            int windowid;
            mywindow7 *popup;


        };

     struct solver_6_mypopup
        {
            int windowid;
            mywindow8 *popup;
        };
     void on_button_6_click(int i,int j,int** sudoku3,Gtk::Button* button_6);
     void on_solve_6_click(int **sudoku4, int **sudoku4_1);
     void on_check_click(int **sudoku4, int **sudoku4_1, Gtk::Button ***buttons_6,Gtk::Grid *grid,std::clock_t &start );
     bool sudoku_solver(int** A);
     void possibility(int A[9][9][10]);
     void pos_unassigned(int A[9][9][10],int add_unassigned[81][2]);
     bool backtrack(int A[9][9][10],int pos_unassgn[][2],int j);
     bool check_valid(int A[9][9][10],int row,int column,int value);
     int read_sud(char level,int **sudoku4);
     void dialog(Glib::ustring msg);
};

#endif // MYWINDOW6_H
